zipparam -quiet 1

set meshSet [lindex $argv 3]
set confFile [lindex $argv 4]

set alignStartRes 3
set alignEndRes 1
set numProcs 1
set fractUsed 1.0

if {$argc > 5} {
    for {set i 5} {$i < $argc} {incr i} {
	set arg [lindex $argv $i]
	if {$arg == "-start"} {
	    incr i
	    set alignStartRes [lindex $argv $i]
	} elseif {$arg == "-finish"} {
	    incr i
	    set alignEndRes [lindex $argv $i]
	} elseif {$arg == "-num_procs"} {
	    incr i
	    set numProcs [lindex $argv $i]
	} elseif {$arg == "-fract_used"} {
	    incr i
	    set fractUsed [lindex $argv $i]
	}
    }
}

set alignIters(4) 30
set alignIters(3) 30
set alignIters(2) 15
set alignIters(1) 5

set fractUsed [expr $fractUsed * 1.0]
zipparam -align_fraction_used $fractUsed

parallel_max $numProcs

bmset $meshSet
flip_norm $meshSet
anchor $meshSet

set fileid [open $confFile "r"]
set count 0
set numchars [gets $fileid line($count)]
incr count
while {$numchars > 0} {
    set numchars [gets $fileid line($count)]
    incr count
}

close $fileid

set count [expr $count -1]

for {set index 0} {$index < $count} {incr index} {
    set curline $line($index)
    if {"bmesh" == [lindex $curline 0]} {
	set meshName [lindex $curline 1]
	eval $curline
	next_align $meshName

	for {set res $alignStartRes} {$res >= $alignEndRes} \
		{set res [expr $res - 1]} {

	    puts -nonewline "Aligning mesh $meshName at resolution $res..."
	    mesh_resolution $res
	    for {set i 0} {$i < $alignIters($res)} {incr i} {
		align_step
	    }
	    set error [align_error]
	    puts "Error: $error"
	}
	puts ""
	mesh_resolution $alignStartRes
	set line($index) [printmesh $meshName]
	remove_mesh $meshName
    }
}


# Write out the updated (transformed) conf file
set fileid [open $confFile "w"]
puts stdout "Writing out to $confFile"
for {set index 0} {$index < $count} {incr index} {
    set curline $line($index)
    puts $fileid $curline
}
close $fileid
exit
